Subject: Re: [PATCH] repack: fix geometric repacking with gitalternates

From: Taylor Blau <[email-masked]>
Date: Tue, 11 Apr 2023 17:14:31 -0400

On Tue, Apr 11, 2023 at 07:26:04PM +0200, Patrick Steinhardt wrote:
> > The problems are quite multi-faceted, but taken on their own most of the
> > problems actually seem quite easy to fix. I've got a local patch series
> > that addresses almost all of the pain points I have found until now:
> >
> > - A segfault in git-multi-pack-index(1) when passed no packfiles and a
> >   preferred packfile that it cannot find.
> >
> > - The issue that git-repack(1) asks git-multi-pack-index(1) to write an
> >   MIDX with packs that it cannot actually track because they are not
> >   local.
> >
> > - An issue with git-pack-objects(1) that keeps it from packing objects
> >   that are non-local due to the way `--stdin-packs` is only referring to
> >   the packfile basenames.
> >
> > - The fact that we don't honor `-l` when doing geometric repacking.
>
> Ah, one more thing I forgot: add a safety mechanism that disables
> writing bitmaps when we see non-local packs.

Thank you very much for working on this.

For what it's worth, I think that this whole thing is pretty cool.
Having a couple of different forges use this feature in subtly different
ways is proving to be an extremely effective way to shake out subtle
bugs in the implementation.

Thanks,
Taylor